-- Time-stamp: <Sat May 24 1997 22:41:20 Stardate: [-31]9379.51 hwloidl>
--
-- Alpha-Beta Search
-- Database of winning positions.
--
-----------------------------------------------------------------------------

--@node Win Positions, Making a Move, Board Manipulation, Top
--@chapter Win Positions

module Wins where

--@menu
--* Type::			
--* List of Win Positions::	
--@end menu

--@node Type, List of Win Positions, Win Positions, Win Positions
--@section Type

type Win = [Int]

--@node List of Win Positions,  , Type, Win Positions
--@section List of Win Positions

wins :: [Win] 
wins = [ -- O captured at 0 (fools check)
         [-1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0], 
         -- O captured at 4 
         [0, 1, 0, 0, -1, 1, 0, 1, 0, 0, 0], 
         -- O captured at 6
         [0, 0, 0, 1, 0, 1, -1, 0, 0, 1, 0]
       ]

