-- Time-stamp: <Sat Jul 26 1997 23:39:06 Stardate: [-31]9694.71 hwloidl>
--
-- Alpha-Beta Search
-- Test Wrapper
--
-----------------------------------------------------------------------------

--@node top, Main, (dir), (dir)
--@top Alpha-Beta Search

--@node Main,  , top, top
--@chapter Main

#if 0 && (defined(GRAN) || defined(GUM))

module Main(mainPrimIO) where

--@node Imports,  , Main, Main
--@section Imports

import PreludeGlaST 

#else

module Main(main) where

#endif
-- --@include Random.hs
-- import Random  (randomInts)    -- Just for testing
#if defined(STRATEGIES)
-- --@include Strategies.lhs
import Strategies
#else
-- --@include ParForce.hs
--import ParForce
#endif

#if (__HASKELL1__==4)
import System
#endif

--import PreludeMonadicIO
--import PreludeIOError
--import LibTime 

--@menu
--* Driver Fct::			
--@end menu

--@include Prog.hs
import Prog (prog)

-- main _ = [ReadChan stdin, AppendChan stdout (prog "")]

#if 0 && (defined(GRAN) || defined(GUM))

#ifdef PRINT
mainPrimIO = getArgsPrimIO  `thenPrimIO` \ a ->
             let 
               all_args = args_to_IntList a     
               game = prog (head all_args) ""
             in 
	       appendChanPrimIO stdout ("\nSearch depth: " ++ (show (head all_args))) `seqPrimIO`
	     appendChanPrimIO stdout ("\nEcho str: " ++ (show game)) `seqPrimIO`
	     returnPrimIO ()
#else
mainPrimIO = getArgsPrimIO  `thenPrimIO` \ a ->
             let 
               all_args = args_to_IntList a     
               game = prog (head all_args) ""
             in 
	       if (foldr ( \ c n -> if (c==' ') then 1 else n) 0 game) == 13
		  then error "Qu'vatlh"
		  else returnPrimIO ()
#endif

#else /* no PrimIO i.e. std Haskell 1.2 */

#if (__HASKELL1__==4)

# ifdef PRINT
main = getArgs >>= \ a ->
             let 
               all_args = args_to_IntList a     
               game = prog (head all_args) ""
             in 
	     putStr ("\nSearch depth: " ++ (show (head all_args)) ++ 
                    "\nGame: " ++ game ++ "\nDone\n") 	     
# else
main = getArgs >>= \ a ->
             let 
               all_args = args_to_IntList a     
               game = prog (head all_args) ""
             in 
	       if (foldr ( \ c n -> if (c==' ') then 1 else n) 0 game) == 13
		  then error "Qu'vatlh"
		  else putStr "done" 
# endif

#else /* !(__HASKELL1__==4) */

# ifdef PRINT
main = getArgs exit $ \ a ->
             let 
               all_args = args_to_IntList a     
               game = prog (head all_args) ""
             in 
	     --appendChan stdout ("\nSearch depth: " ++ (show (head all_args))) exit $ 
	     --appendChan stdout ("\nEcho str: " ++ (show game)) exit done )
	     print ("\nSearch depth: " ++ (show (head all_args)) ++ 
                    "\nGame: " ++ game ++ "\nDone\n") 	     
# else
main = getArgs exit $ \ a ->
             let 
               all_args = args_to_IntList a     
               game = prog (head all_args) ""
             in 
	       if sum (map ord game) == 13
		  then error "Qu'vatlh"
		  else appendChan stdout "done" exit done
# endif

#endif

#endif

args_to_IntList :: [String] -> [Int]
args_to_IntList = map read

-----------------------------------------------------------------------------

{-
	      max = 65535
	      randomList = map (`mod` max) (randomInts  (getRandInt max) 
							(getRandInt (max-1)) )

	      l' = take 5000 randomList  -- [54,53..2]::[Int]
	      l = par_qsort expensive_le l'

	      expensive_le x y = (sum [x..x+3]) <= (sum [y..y+3])

	      sorted l = and (zipWith (<=) l (tail l))

getRandInt :: Int -> Int
getRandInt bound = 
  unsafePerformPrimIO ( 
    getClockTime `thenPrimIO` \ t ->
    returnPrimIO (
    case t of 
    	Left _ -> error "error in getClockTime"
    	Right b -> let 
    		     CalendarTime _ _ _ _ _ _ x _ _ _ _ _  = toCalendarTime b
    		   in 
    		     ((fromInteger x) `mod` bound) :: Int )  )


-}
